﻿#region Using directives

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;
using System.Workflow.Activities;

#endregion

namespace Chapter3
{
    class Program
    {
        static void Main(string[] args)
        {
            WorkflowRuntime runtime = new WorkflowRuntime();

            ExternalDataExchangeService dataService;
            dataService = new ExternalDataExchangeService();
            runtime.AddService(dataService);

            BugFlowService bugFlow = new BugFlowService();
            dataService.AddService(bugFlow);

            AutoResetEvent waitHandle = new AutoResetEvent(false);
            runtime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) { waitHandle.Set(); };
            runtime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e) { waitHandle.Set(); };

            WorkflowInstance instance;
            instance = runtime.CreateWorkflow(typeof(BugFlow));
            instance.Start();

            Bug bug = new Bug(1, "Bug Title", "Bug Description");
            bugFlow.CreateBug(instance.InstanceId, bug);

            waitHandle.WaitOne();
            Console.Read();

        }
    }
}
